<script>
import { openDB } from 'idb';

export default {
    /******************************
     * The props are variables which are given by the parent component. This is the mean to use data from a parent component in a child component.
     ******************************/
    props: {
        isOfflineState: {
            type: Boolean,
            default: false
        },
        objectTypesList: {
            type: Object,
            default: {}
        }
    },
    /******************************
     * The emits are events which can be emited by a component  and received by a parent component. This is the mean to use data from a child component in a parent component (this.$emit('event-to-emit', data-to-emit)).
     ******************************/
    emits: ['close-modal', 'change-to-online', 'download-selected-data', 're-download-selected-data'],
    data() {
        return {
            showListOfLayersWhenOffline: false,
            selectedLayers: []
        }
    },
    methods: {
        // replaceApostrophe(str) {
        //     if(typeof str === 'string') {
        //         return str.replaceAll("&#039;", "'");
        //     }
        // },
        decodeHTMLEntities(text) {
            return (text + "").replace(/&#\d+;/gm, function (s) {
                return String.fromCharCode(s.match(/\d+/gm)[0]);
            });
        },
    },



    /******************************
     * At the creation of the component, creates the IndexedDB databases and stores.
     ******************************/
    async created() {
        await openDB('sysmaDictDB', 1, {
            upgrade(db) {
                const store = db.createObjectStore('dictionnaires', {
                    keyPath: 'id',
                    autoIncrement: true,
                });
                store.createIndex('id', 'id');
            },
        });

        await openDB('sysmaLayersDB', 1, {
            upgrade(db) {
                const layerStore = db.createObjectStore('layers', {
                    keyPath: 'layerID',
                    autoIncrement: true,
                });
                layerStore.createIndex('layerID', 'layerID');
            }
        });
    }
}
</script>

<template>
    <div id="sysmaMobileModal" class="mobile-mode-modal-background"
    @click="$emit('close-modal'); showListOfLayersWhenOffline = false;">
        <div class="modal-dialog" style="height: 80%;overflow-y: auto;" @click.stop="">
            <div class="modal-content" style="height: 100%;overflow-y: auto;">
                <div class="modal-header">
                    <button class="btn btn-default" style="float:right;" id="closeModalWindowButton"
                        @click="$emit('close-modal'); showListOfLayersWhenOffline = false;">
                        <span class="glyphicon glyphicon-remove" title="Annuler"></span>
                        Annuler
                    </button>
                    <!-- 
                                    <h2 v-show="!isOfflineState">Préparation au passage de Sysma en mode hors-ligne.</h2>
                                    <h3 v-show="!isOfflineState">1) Téléchargement des fonds de carte:<br><br>- Vérifier que vous avez séléctionner les fonds de cartes dont vous aurez besoin.<br>- Vérifier que la vue de la carte contient votre zone de travail.</h3>
                                    <h4 v-show="!isOfflineState">Attention! Afin de limiter les téléchargements, l'échelle maximale de la carte est automatiquement limitée à 1km (limite de niveau de zoom >= 13).</h4>
                                    <h3 v-show="!isOfflineState">2) Sélectioner les couches de travail à charger : </h3>
                                    <h3 v-show="isOfflineState">Sysma est en mode hors-ligne</h3>
                                    -->
                    <h2 v-show="!isOfflineState">Préparation au mode Hors-ligne</h2>
                    <ul v-show="!isOfflineState">
                        <li>Vérifiez que vous avez séléctionné les fonds de cartes dont vous aurez besoin</li>
                        <li>Vérifiez que la vue de la carte est ajustée à votre zone de travail</li>
                    </ul>
                    <p>Info: afin de limiter les téléchargements des fonds de carte, l'échelle maximale de la carte est
                        automatiquement limitée à 1km.</p>

                    <h3 v-show="isOfflineState">Sysma est en mode hors-ligne</h3>
                </div>

                <div class="modal-body" style="overflow-y: auto">
                    <form v-show="(!isOfflineState) || showListOfLayersWhenOffline" id="terrainPrepareForm">
                        <div class="form-group">
                            <h2 v-show="!isOfflineState">Sélectionner vos couches hors-ligne : </h2>
                            <template
                                v-for="objectTypeID in Object.keys(objectTypesList).sort((a, b) => { return objectTypesList[a].localeCompare(objectTypesList[b]); })"
                                :key="objectTypeID">
                                <label>
                                    <input v-model="selectedLayers" type="checkbox" :value="parseInt(objectTypeID)"
                                        :name="objectTypesList[objectTypeID]" :id="objectTypeID + 'input'">
                                    <!-- <input v-model="selectedLayers" type="checkbox" 
                                                    :value="option"
                                                    :name="objectTypesList[option]['sysmaObjectTypeAlias']"
                                                    :sotid="objectTypesList[option]['sysmaObjectTypeID']"> -->

                                    {{ " " + decodeHTMLEntities(objectTypesList[objectTypeID]) }}
                                </label>
                                <br>
                            </template>
                        </div>
                    </form>
                </div>

                <div class="modal-footer" style="text-align: center;">
                    <!-- <button v-show="!isOfflineState" class="btn btn-primary" id="offlineLayersUploadButton"
                                        @click="downloadSelectedData(true).then(status => { handleDownloadStatus(status); });">
                                        Télécharger ma sélection
                                    </button> -->
                    <button v-show="!isOfflineState" class="btn btn-primary" id="offlineLayersUploadButton"
                        @click="$emit('download-selected-data', selectedLayers)">
                        Télécharger les données et passer en mode Hors-ligne
                    </button>
                    <button v-show="isOfflineState && (!showListOfLayersWhenOffline)" class="btn btn-primary"
                        id="uploadLayersButton"
                        @click="$emit('close-modal'); $emit('change-to-online', JSON.stringify(selectedLayers));">
                        Envoyer les données au serveur <br> et passer en mode en-ligne
                    </button>
                    <!-- <input v-show="false" id="onlineModeLayerManager" @click="onlineModeLayerManager" /> -->
                    <br><br>
                    <!-- <button v-show="isOfflineState && showListOfLayersWhenOffline" class="btn btn-primary" id="reDownloadLayersButton"
                                        @click="downloadSelectedData(); $emit('close-modal'); mobileModeLayerManager(); showListOfLayersWhenOffline=false;">
                                        Télécharger ma sélection
                                    </button> -->
                    <button v-show="isOfflineState && showListOfLayersWhenOffline" class="btn btn-primary"
                        id="reDownloadLayersButton"
                        @click="$emit('re-download-selected-data', selectedLayers); showListOfLayersWhenOffline = false;">
                        Télécharger la sélection
                    </button>
                    <button v-show="isOfflineState && (!showListOfLayersWhenOffline)" class="btn btn-primary"
                        id="revalidateLayersButton" @click="showListOfLayersWhenOffline = true;">
                        Resélectionner les couches <br> et rester en mode hors-ligne
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<style>
.mobile-mode-modal-background {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    height: 100%;
    background-color: rgba(0, 0, 0, 0.3);
    display: flex;
    justify-content: center;
    align-items: center;
    z-index: 1000;
    overflow-y: auto;
}
</style>